diff --git a/modules/services/serviceWeb/mainServiceWeb.py b/modules/services/serviceWeb/mainServiceWeb.py
index 469ca6ae..b6b90374 100644
--- a/modules/services/serviceWeb/mainServiceWeb.py
+++ b/modules/services/serviceWeb/mainServiceWeb.py
@@ -85,22 +85,119 @@ class WebService:
             if extractedUrls:
                 allUrls.extend(extractedUrls)
             
-            # Step 2: Search for URLs if needed (based on needsSearch flag)
+            # Step 2: Search for URLs and content if needed (based on needsSearch flag)
+            searchUrls = []
+            searchResultsWithContent = []
             if needsSearch and (not allUrls or len(allUrls) < maxNumberPages):
-                self.services.chat.progressLogUpdate(operationId, 0.3, "Searching for URLs")
+                self.services.chat.progressLogUpdate(operationId, 0.3, "Searching for URLs and content")
                 
-                searchUrls = await self._performWebSearch(
-                    instruction=instruction,
-                    maxNumberPages=maxNumberPages - len(allUrls),
-                    country=countryCode,
-                    language=languageCode
-                )
+                try:
+                    searchUrls, searchResultsWithContent = await self._performWebSearch(
+                        instruction=instruction,
+                        maxNumberPages=maxNumberPages - len(allUrls),
+                        country=countryCode,
+                        language=languageCode
+                    )
+                    logger.info(f"Tavily search returned {len(searchUrls)} URLs with {len(searchResultsWithContent)} results containing content")
+                except Exception as e:
+                    logger.error(f"Error performing Tavily search (continuing with other URLs): {str(e)}", exc_info=True)
+                    searchUrls = []
+                    searchResultsWithContent = []
                 
-                # Add search URLs to the list
-                allUrls.extend(searchUrls)
+                # Prioritize Tavily search URLs over AI-extracted URLs (they're more relevant)
+                if searchUrls:
+                    # Prepend Tavily URLs to the list (they're more relevant)
+                    allUrls = searchUrls + allUrls
+                    logger.info(f"Using {len(searchUrls)} Tavily URLs + {len(allUrls) - len(searchUrls)} other URLs = {len(allUrls)} total")
+                else:
+                    # If Tavily search failed, use AI-extracted URLs
+                    logger.warning("Tavily search returned no URLs, using AI-extracted URLs only")
                 
                 self.services.chat.progressLogUpdate(operationId, 0.5, f"Found {len(allUrls)} total URLs")
             
+            # If we have search results (even without content), use them directly instead of crawling
+            # Tavily search results are more relevant than generic AI-extracted URLs
+            # Only crawl if we have NO search results at all
+            if searchResultsWithContent and len(searchResultsWithContent) > 0:
+                urls_with_actual_content = sum(1 for r in searchResultsWithContent if r.get("content") and len(r.get("content", "")) > 0)
+                logger.info(f"Using {len(searchResultsWithContent)} Tavily search results ({urls_with_actual_content} with content) directly (skipping crawl)")
+                
+                # Convert search results to crawl result format
+                crawlResult = []
+                for result in searchResultsWithContent:
+                    crawlResult.append({
+                        "url": result["url"],
+                        "title": result.get("title", ""),
+                        "content": result.get("content", "")
+                    })
+                
+                # Calculate statistics
+                totalResults = len(crawlResult)
+                totalContentLength = sum(len(r.get("content", "")) for r in crawlResult)
+                urlsWithContent = sum(1 for r in crawlResult if r.get("content") and len(r.get("content", "")) > 0)
+                
+                # Log content availability
+                if urlsWithContent == 0:
+                    logger.warning(f"Tavily search returned {len(searchResultsWithContent)} results but none have content - URLs will be used but may need crawling")
+                else:
+                    logger.info(f"Tavily search provided content for {urlsWithContent}/{len(searchResultsWithContent)} URLs")
+                
+                # Even if content is empty, use these results - they're more relevant than generic URLs
+                # The final answer generation can work with URLs even if content is empty
+                
+                # Convert to sections format
+                sections = []
+                for idx, item in enumerate(crawlResult):
+                    section = {
+                        "id": f"result_{idx}",
+                        "content_type": "paragraph",
+                        "title": item.get("title") or item.get("url", f"Result {idx + 1}"),
+                        "order": idx
+                    }
+                    content = item.get("content", "")
+                    if content:
+                        section["textPreview"] = content[:200] + ("..." if len(content) > 200 else "")
+                    sections.append(section)
+                
+                # Return consolidated result
+                result = {
+                    "metadata": {
+                        "title": suggestedFilename or instruction[:100] if instruction else "Web Research Results",
+                        "extraction_method": "tavily_search_direct",
+                        "research_depth": finalResearchDepth,
+                        "country": countryCode,
+                        "language": languageCode,
+                        "urls_searched": searchUrls[:20],
+                        "total_urls": len(searchUrls),
+                        "urls_with_content": urlsWithContent,
+                        "total_content_length": totalContentLength,
+                        "search_date": self.services.utils.timestampGetUtc() if hasattr(self.services, 'utils') else None
+                    },
+                    "sections": sections,
+                    "statistics": {
+                        "sectionCount": len(sections),
+                        "total_urls": len(searchUrls),
+                        "results_count": totalResults,
+                        "urls_with_content": urlsWithContent,
+                        "total_content_length": totalContentLength
+                    },
+                    "instruction": instruction,
+                    "urls_crawled": searchUrls,
+                    "total_urls": len(searchUrls),
+                    "results": crawlResult,
+                    "total_results": totalResults
+                }
+                
+                if suggestedFilename:
+                    result["suggested_filename"] = suggestedFilename
+                    result["metadata"]["suggested_filename"] = suggestedFilename
+                
+                if operationId:
+                    self.services.chat.progressLogUpdate(operationId, 0.9, "Completed")
+                    self.services.chat.progressLogFinish(operationId, True)
+                
+                return result
+            
             # Step 3: Validate and filter URLs before crawling
             validatedUrls = self._validateUrls(allUrls)
             if not validatedUrls:
@@ -322,8 +419,16 @@ Return ONLY valid JSON, no additional text:
         maxNumberPages: int,
         country: Optional[str],
         language: Optional[str]
-        ) -> List[str]:
-        """Perform web search to find URLs."""
+        ) -> tuple[List[str], List[Dict[str, Any]]]:
+        """
+        Perform web search to find URLs and content.
+        
+        Returns:
+            Tuple of (urls, search_results_with_content)
+            - urls: List of URL strings
+            - search_results_with_content: List of dicts with url, title, content from Tavily search
+        """
+        search_results_with_content = []
         try:
             # Build search prompt model
             searchPromptModel = AiCallPromptWebSearch(
@@ -350,46 +455,224 @@ Return ONLY valid JSON, no additional text:
                 outputFormat="json"
             )
             
+            # Check if metadata contains results with content (from Tavily)
+            if hasattr(searchResponse, 'metadata') and searchResponse.metadata:
+                # Check in additionalData first (where we store custom metadata)
+                additional_data = None
+                if hasattr(searchResponse.metadata, 'additionalData') and searchResponse.metadata.additionalData:
+                    additional_data = searchResponse.metadata.additionalData
+                elif isinstance(searchResponse.metadata, dict):
+                    additional_data = searchResponse.metadata.get("additionalData", {})
+                
+                if additional_data:
+                    results_with_content = additional_data.get("results_with_content", [])
+                    if results_with_content:
+                        logger.info(f"Found {len(results_with_content)} search results with content in metadata.additionalData")
+                        # Extract URLs and content from metadata
+                        for result in results_with_content:
+                            if result.get("url"):
+                                search_results_with_content.append({
+                                    "url": result.get("url"),
+                                    "title": result.get("title", ""),
+                                    "content": result.get("content", ""),
+                                    "score": result.get("score", 0)
+                                })
+                
+                # Also check directly in metadata (fallback)
+                if not search_results_with_content:
+                    results_with_content = None
+                    if hasattr(searchResponse.metadata, 'results_with_content'):
+                        results_with_content = searchResponse.metadata.results_with_content
+                    elif isinstance(searchResponse.metadata, dict):
+                        results_with_content = searchResponse.metadata.get("results_with_content", [])
+                    
+                    if results_with_content:
+                        logger.info(f"Found {len(results_with_content)} search results with content in metadata (direct)")
+                        for result in results_with_content:
+                            if result.get("url"):
+                                search_results_with_content.append({
+                                    "url": result.get("url"),
+                                    "title": result.get("title", ""),
+                                    "content": result.get("content", ""),
+                                    "score": result.get("score", 0)
+                                })
+            
             # Extract content from AiResponse
             searchResult = searchResponse.content
             
+            logger.debug(f"Search response content type: {type(searchResult)}, length: {len(str(searchResult)) if searchResult else 0}")
+            
             # Debug: persist search response
             if isinstance(searchResult, str):
                 self.services.utils.writeDebugFile(searchResult, "websearch_response")
+                logger.debug(f"Search response (first 500 chars): {searchResult[:500]}")
             else:
                 self.services.utils.writeDebugFile(json.dumps(searchResult, indent=2), "websearch_response")
+                logger.debug(f"Search response type: {type(searchResult)}, keys: {list(searchResult.keys()) if isinstance(searchResult, dict) else 'N/A'}")
             
-            # Parse and extract URLs
+            # Parse and extract URLs and content
             if isinstance(searchResult, str):
                 # Extract JSON from response (handles markdown code blocks)
                 extractedJson = self.services.utils.jsonExtractString(searchResult)
-                searchData = json.loads(extractedJson) if extractedJson else json.loads(searchResult)
+                if extractedJson:
+                    try:
+                        searchData = json.loads(extractedJson)
+                        logger.debug(f"Parsed JSON from extracted string, type: {type(searchData)}")
+                    except json.JSONDecodeError as e:
+                        logger.warning(f"Failed to parse extracted JSON: {e}, trying direct parse")
+                        searchData = json.loads(searchResult)
+                else:
+                    try:
+                        searchData = json.loads(searchResult)
+                        logger.debug(f"Parsed JSON directly from string, type: {type(searchData)}")
+                    except json.JSONDecodeError as e:
+                        logger.error(f"Failed to parse search result as JSON: {e}")
+                        searchData = {}
             else:
                 searchData = searchResult
+                logger.debug(f"Using searchResult directly as searchData, type: {type(searchData)}")
             
-            # Extract URLs from response
+            logger.debug(f"Final searchData type: {type(searchData)}, is dict: {isinstance(searchData, dict)}, keys: {list(searchData.keys()) if isinstance(searchData, dict) else 'N/A'}")
+            
+            # Extract URLs and content from response
             urls = []
             if isinstance(searchData, dict):
-                if "urls" in searchData:
+                # Check for new format: {"urls": [...], "results": [...]}
+                if "urls" in searchData and "results" in searchData:
                     urls = searchData["urls"]
+                    # Extract results with content
+                    for r in searchData["results"]:
+                        if r.get("url"):
+                            # Only add if not already added from metadata
+                            if not any(sr["url"] == r.get("url") for sr in search_results_with_content):
+                                search_results_with_content.append({
+                                    "url": r.get("url"),
+                                    "title": r.get("title", ""),
+                                    "content": r.get("content", ""),
+                                    "score": r.get("score", 0)
+                                })
+                    logger.debug(f"Extracted {len(urls)} URLs and {len(search_results_with_content)} results with content from new format")
+                elif "urls" in searchData:
+                    urls = searchData["urls"]
+                    logger.debug(f"Extracted {len(urls)} URLs from 'urls' field")
                 elif "results" in searchData:
-                    urls = [r.get("url") for r in searchData["results"] if r.get("url")]
+                    # Extract URLs from results (content already in search_results_with_content if from metadata)
+                    for r in searchData["results"]:
+                        if r.get("url"):
+                            urls.append(r.get("url"))
+                            # Only add to search_results_with_content if not already added from metadata
+                            if not any(sr["url"] == r.get("url") for sr in search_results_with_content):
+                                search_results_with_content.append({
+                                    "url": r.get("url"),
+                                    "title": r.get("title", ""),
+                                    "content": r.get("raw_content") or r.get("content", ""),
+                                    "score": r.get("score", 0)
+                                })
+                    logger.debug(f"Extracted {len(urls)} URLs with content from 'results' field")
+                else:
+                    logger.warning(f"Unexpected search data structure (dict): {list(searchData.keys())}")
             elif isinstance(searchData, list):
                 # Handle both cases: list of URL strings or list of dicts with "url" key
                 for item in searchData:
                     if isinstance(item, str):
                         # Item is already a URL string
                         urls.append(item)
-                    elif isinstance(item, dict) and item.get("url"):
-                        # Item is a dict with "url" key
-                        urls.append(item.get("url"))
+                    elif isinstance(item, dict):
+                        if item.get("url"):
+                            urls.append(item.get("url"))
+                            # Only add to search_results_with_content if not already added from metadata
+                            if not any(sr["url"] == item.get("url") for sr in search_results_with_content):
+                                search_results_with_content.append({
+                                    "url": item.get("url"),
+                                    "title": item.get("title", ""),
+                                    "content": item.get("raw_content") or item.get("content", ""),
+                                    "score": item.get("score", 0)
+                                })
+                logger.debug(f"Extracted {len(urls)} URLs from list")
+            else:
+                logger.warning(f"Unexpected search data type: {type(searchData)}")
             
-            logger.info(f"Web search returned {len(urls)} URLs")
-            return urls
+            # If we got URLs but no content from metadata, extract URLs from search_results_with_content
+            if urls and not search_results_with_content:
+                # URLs were extracted but no content - create entries with empty content
+                for url in urls:
+                    search_results_with_content.append({
+                        "url": url,
+                        "title": "",
+                        "content": "",
+                        "score": 0
+                    })
+            elif search_results_with_content and not urls:
+                # We have content but no URLs - extract URLs from content results
+                urls = [r["url"] for r in search_results_with_content]
+            
+            # If we have URLs but no search_results_with_content, create entries from URLs
+            # This ensures we can use Tavily URLs even if content extraction failed
+            if urls and not search_results_with_content:
+                logger.warning("Got URLs from Tavily search but no content extracted - creating entries for direct use")
+                for url in urls:
+                    search_results_with_content.append({
+                        "url": url,
+                        "title": "",
+                        "content": "",  # Empty content - will need crawling if used
+                        "score": 0
+                    })
+            
+            logger.info(f"Web search returned {len(urls)} URLs with {len(search_results_with_content)} results")
+            if search_results_with_content:
+                content_count = sum(1 for r in search_results_with_content if r.get("content") and len(r.get("content", "")) > 0)
+                logger.info(f"  - {content_count} results have content, {len(search_results_with_content) - content_count} without content")
+                if content_count > 0:
+                    first_with_content = next((r for r in search_results_with_content if r.get("content")), None)
+                    if first_with_content:
+                        logger.info(f"Content preview from first result with content: {first_with_content.get('content', '')[:200]}")
+            else:
+                logger.warning("No search results extracted - will need to crawl URLs")
+            return urls, search_results_with_content
             
         except Exception as e:
-            logger.error(f"Error in web search: {str(e)}")
-            return []
+            logger.error(f"Error in web search: {str(e)}", exc_info=True)
+            # Even if there's an error, try to extract URLs from the response if available
+            recovered_urls = []
+            recovered_results = []
+            try:
+                if 'searchResponse' in locals() and searchResponse:
+                    logger.info(f"Attempting to extract URLs from error response: {type(searchResponse)}")
+                    # Try to get content from response
+                    if hasattr(searchResponse, 'content'):
+                        errorContent = searchResponse.content
+                        if isinstance(errorContent, str):
+                            # Try to parse as JSON
+                            try:
+                                errorData = json.loads(errorContent)
+                                if isinstance(errorData, dict):
+                                    if "urls" in errorData:
+                                        recovered_urls = errorData["urls"]
+                                    elif "results" in errorData:
+                                        recovered_urls = [r.get("url") for r in errorData["results"] if r.get("url")]
+                                        recovered_results = [{"url": r.get("url"), "title": r.get("title", ""), "content": r.get("content", ""), "score": 0} for r in errorData["results"]]
+                                elif isinstance(errorData, list):
+                                    recovered_urls = [item if isinstance(item, str) else item.get("url", "") for item in errorData if item]
+                                if recovered_urls:
+                                    logger.info(f"Recovered {len(recovered_urls)} URLs from error response")
+                                    # Create entries for recovered URLs
+                                    if not recovered_results:
+                                        for url in recovered_urls:
+                                            recovered_results.append({"url": url, "title": "", "content": "", "score": 0})
+                                    return recovered_urls, recovered_results
+                            except Exception as parseError:
+                                logger.debug(f"Failed to parse error response: {parseError}")
+            except Exception as recoverError:
+                logger.debug(f"Failed to recover URLs from error: {recoverError}")
+            
+            # If we have URLs from earlier extraction, return them
+            if 'urls' in locals() and urls:
+                logger.info(f"Returning {len(urls)} URLs extracted before error occurred")
+                # Create entries from URLs
+                results_from_urls = [{"url": url, "title": "", "content": "", "score": 0} for url in urls]
+                return urls, results_from_urls
+            
+            return [], []
     
     def _validateUrls(self, urls: List[str]) -> List[str]:
         """

